<?php
/*
Plugin Name: WooCommerce COD fee
Description: Add fee to Cash on Delivery payment method
Author: dot4all S.r.l.
Author URI: http://dot4all.it
Version: 1
*/

/**
 * Required functions
 **/
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
	
	if ( ! class_exists( 'WC_COD_fee' ) ) {
	 
		class WC_COD_fee {
			
			public function __construct() {
				
				// set cod fee
				add_action( 'edit_post', array( &$this, 'set_cod_fee' ), 10, 2 );
			}
			/**
			 * Set the COD fee
			 * 
			 * @param int $post_id post identifier
			 * @param object $post post object
			 */
			public function set_cod_fee( $post_id, $post ) {
				if ( $post->post_type == 'shop_order' ) {
					$payment_type = get_post_meta( $post_id, '_payment_method', true );
					if ( $payment_type == "cod") {
						$cod_fee = 3.90;
						$order_total = get_post_meta( $post_id, '_order_total', true );
						update_post_meta($post_id, '_order_total', $order_total+$cod_fee);
					}
				}
			}	
		}
	}
	$GLOBALS['wc_cod_fee'] = new WC_COD_fee();
}
?>